/*
 * $Id: game.c,v 1.1 2001/12/03 04:20:06 bsulcer Exp $
 * Copyright (c) 2001 Brian Sulcer <bsulcer@pobox.com>
 *
 * This file is part of Not One for PalmOS.
 *
 * Not One for PalmOS is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * Not One for PalmOS is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Not One for PalmOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#include <PalmOS.h>
#include "resources.h"
#include "constants.h"

UInt32 round = 0;
UInt32 die1 = 0;
UInt32 die2 = 0;
UInt32 playerScore = 0;
UInt32 palmScore = 0;
UInt32 roundTotal = 0;
UInt32 firstRoll = 0;
UInt8 turn = 0; /* 0 = player, 1 = palm */
UInt8 numRolls = 0;

static UInt8 strategy[12] = { 0, 18, 18, 9, 9, 6, 6, 6, 9, 9, 18, 18 };

void NewGame() {
  round = 1;
  playerScore = 0;
  palmScore = 0;
  roundTotal = 0;
  firstRoll = 0;
  turn = 0;
  die1 = 0;
  die2 = 0;
  numRolls = 0;
  SysRandom(TimGetTicks());
}

void RollDice() {
  UInt32 totalRoll;

  die1 = (SysRandom(0) % 6) + 1;
  die2 = (SysRandom(0) % 6) + 1;
  totalRoll = die1 + die2;
  numRolls++;

  if (firstRoll == 0) {
    firstRoll = totalRoll;
    roundTotal = totalRoll;
  }
  else {
    if (totalRoll == firstRoll) {
      roundTotal = 0;
    }
    else {
      roundTotal += totalRoll;
    }
  }
  
}

void EndTurn() {
  if (turn == 0) {
    playerScore += roundTotal;
    turn = 1;
  }
  else {
    palmScore += roundTotal;
    turn = 0;
    round++;
  }

  die1 = 0;
  die2 = 0;
  roundTotal = 0;
  firstRoll = 0;
  numRolls = 0;
}

Boolean ComputerWillRoll() {
  UInt8 maxNumRolls = strategy[firstRoll];
  if (numRolls < maxNumRolls) {
    return true;
  }
  else {
    return false;
  }
}
