/*
 * $Id: prefs.c,v 1.1 2001/12/03 04:20:06 bsulcer Exp $
 * Copyright (c) 2001 Brian Sulcer <bsulcer@pobox.com>
 *
 * This file is part of Not One for PalmOS.
 *
 * Not One for PalmOS is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * Not One for PalmOS is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Not One for PalmOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#include <PalmOS.h>
#include "constants.h"
#include "prefs.h"
#include "game.h"

void
LoadPrefs()
{
  AppPrefs prefs;
  UInt16 prefsSize = 0;
  Int16 gotSize;

  PrefGetAppPreferences(kAppFileCreator, 0, NULL, &prefsSize, false);

  if (prefsSize > 0) {
    gotSize = PrefGetAppPreferences(kAppFileCreator, 0, &prefs, &prefsSize,
				    false);
    if (gotSize == prefsSize) {
      ErrDisplay("size mismatch in get prefs");
    }
    
    round = prefs.round;
    die1 = prefs.die1;
    die2 = prefs.die2;
    playerScore = prefs.playerScore;
    palmScore = prefs.palmScore;
    roundTotal = prefs.roundTotal;
    firstRoll = prefs.firstRoll;
    turn = prefs.turn;
    numRolls = prefs.numRolls;
  }
}

void
SavePrefs()
{
  AppPrefs prefs;

  prefs.round = round;
  prefs.die1 = die1;
  prefs.die2 = die2;
  prefs.playerScore = playerScore;
  prefs.palmScore = palmScore;
  prefs.roundTotal = roundTotal;
  prefs.firstRoll = firstRoll;
  prefs.turn = turn;
  prefs.numRolls = numRolls;

  PrefSetAppPreferences(kAppFileCreator, 0, kAppVersion, &prefs, sizeof(prefs),
			false);
}
